From 8e6ee0e31e25238ff8ea50938a20f1775001c88d Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Mon, 27 Sep 2021 00:14:09 -0700
Subject: [PATCH v5 08/16] meson: prereq: generate-errcodes.pl: accept output
 file

---
 src/backend/utils/Makefile             |  2 +-
 src/backend/utils/generate-errcodes.pl | 13 ++++++++-----
 src/tools/msvc/Solution.pm             |  2 +-
 3 files changed, 10 insertions(+), 7 deletions(-)

diff --git a/src/backend/utils/Makefile b/src/backend/utils/Makefile
index ef8df254826..469caf0d704 100644
--- a/src/backend/utils/Makefile
+++ b/src/backend/utils/Makefile
@@ -52,7 +52,7 @@ fmgr-stamp: Gen_fmgrtab.pl $(catalogdir)/Catalog.pm $(top_srcdir)/src/include/ca
 	touch $@
 
 errcodes.h: $(top_srcdir)/src/backend/utils/errcodes.txt generate-errcodes.pl
-	$(PERL) $(srcdir)/generate-errcodes.pl $< > $@
+	$(PERL) $(srcdir)/generate-errcodes.pl $< $@
 
 ifneq ($(enable_dtrace), yes)
 probes.h: Gen_dummy_probes.sed
diff --git a/src/backend/utils/generate-errcodes.pl b/src/backend/utils/generate-errcodes.pl
index c5cdd388138..57ec2a5ca21 100644
--- a/src/backend/utils/generate-errcodes.pl
+++ b/src/backend/utils/generate-errcodes.pl
@@ -6,11 +6,13 @@
 use strict;
 use warnings;
 
-print
+open my $errcodes, '<', $ARGV[0] or die;
+open my $out, '>', $ARGV[1] or die;
+
+print $out
   "/* autogenerated from src/backend/utils/errcodes.txt, do not edit */\n";
-print "/* there is deliberately not an #ifndef ERRCODES_H here */\n";
+print $out "/* there is deliberately not an #ifndef ERRCODES_H here */\n";
 
-open my $errcodes, '<', $ARGV[0] or die;
 
 while (<$errcodes>)
 {
@@ -25,7 +27,7 @@ while (<$errcodes>)
 	{
 		my $header = $1;
 		$header =~ s/^\s+//;
-		print "\n/* $header */\n";
+		print $out "\n/* $header */\n";
 		next;
 	}
 
@@ -40,7 +42,8 @@ while (<$errcodes>)
 	# And quote them
 	$sqlstate =~ s/([^,])/'$1'/g;
 
-	print "#define $errcode_macro MAKE_SQLSTATE($sqlstate)\n";
+	print $out "#define $errcode_macro MAKE_SQLSTATE($sqlstate)\n";
 }
 
 close $errcodes;
+close $out;
diff --git a/src/tools/msvc/Solution.pm b/src/tools/msvc/Solution.pm
index dc78d3b65c3..40cd6020421 100644
--- a/src/tools/msvc/Solution.pm
+++ b/src/tools/msvc/Solution.pm
@@ -659,7 +659,7 @@ sub GenerateFiles
 	{
 		print "Generating errcodes.h...\n";
 		system(
-			'perl src/backend/utils/generate-errcodes.pl src/backend/utils/errcodes.txt > src/backend/utils/errcodes.h'
+			'perl src/backend/utils/generate-errcodes.pl src/backend/utils/errcodes.txt src/backend/utils/errcodes.h'
 		);
 		copyFile('src/backend/utils/errcodes.h',
 			'src/include/utils/errcodes.h');
-- 
2.23.0.385.gbc12974a89

